// -- Ammo boost and Drop on death ---------------------------------------------
brutalv22-ammo_boost_start (v1)
  * Initial release
 -- Edewaa Mon, 10 May 2025 11:31 +0200

brutalv22-ammo_boost_start (v1.1)
  * Added feature to give respawning players ammo if they currently have less
    than the minimum intended amount
  * Adjusted minimum ammo amounts
  * Give melee class Berserk pack at start
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sun, 22 June 2025 15:27:53 -0500

brutalv22_ammo_start_and_drop_on_death (v1.2)
  * Rename mod to brutalv22_ammo_start_and_drop_death
  * Combine functionality of brutalv22-drop_inventory_death with this mod,
    because we need to know the starting loadout of each class in order to
    deduct that from what is dropped on death
  * Move actors/PlayerClasses/Footsteps.dec to
    brutalv22_gren_melee_and_downanywhere_support v1.5 and later
  * Also drop the Beam Katana on death
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sun, 06 July 2025 12:47:05 -0500
 
brutalv22_ammo_start_and_drop_on_death (v1.3pre)
  * On death, drop consumable items of "consumables_from_complex_doom"
  * Ensure that melee class has the riot shield on spawn
 -- PapuSlayer  Sat, 23 August 2025 12:13:15 -0400

brutalv22_ammo_start_and_drop_on_death (v1.3)
  * Improve formatting of source code and documentation
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sun, 24 August 2025 13:02:33 -0500

// -- brutalv22_gren_melee_and_downanywhere_support ----------------------------

brutalv22-smaller_grenade_radius_fix (v1)
  * Prevent grenades from bouncing too much when lauching them in the
    air. The cause was use of A_ThrowGrenade instead of BDv21's use
    of A_FireCustomMissile
  * Reduce grenade damage radius
 -- Edewaa Mon, 12 May 2025 11:31 +0200

brutalv22-grenade_changes_and_downanywhere_support (v1)
  * Add EZDowned state to PlayerPawn that makes a death scream and
    the player collapses and appears to be a corpse. But, it does not
    make the player nonsolid. As long as msod_downanywhere uses the
    "EZDowned" state instead of "Death" then this should prevent players
    from getting stuck on a downed player
  * Prevent players from throwing grenades while downed
  * Prevent players from kicking or slide kicking while downed
  * Add A_Raise commands at the end of the TossGrenade and DoKick states in
    order to reduce or eliminate the chances of the weapon getting stuck
    lowered when an an attempt to throw a grenade is blocked due to
    lack of ammo or the player being downed
  * Prevent dealing damage to other players by holding the use key
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sat, 07 June 2025 14:23:53 -0500

brutalv22-grenade_changes_and_downanywhere_support (v1.1)
  * Prevent Grab and Stealth attacks, because the high damage disrupts
    cooperative gameplay when players are reviving each other
  * Prevent downed and aiding players from doing anything related to grabbing,
    including executions, throws, stealth attacks, picking up monsters or
    barrels, etc.
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sun, 08 June 2025 23:47:28 -0500

brutalv22-grenade_changes_and_downanywhere_support (v1.2)
  * Prevent dodge rolling, taunting, saluting, kicking, fatalities, etc., if
    the player is disallowed from attacking by MSoD_DownAnywhere
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sun, 15 June 2025 16:10:25 -0500

brutalv22-grenade_changes_and_downanywhere_support (v1.3)
  * Fix typos in EZDowned.Prone state
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Mon, 16 June 2025 16:52:31 -0500

brutalv22_gren_melee_and_downanywhere_support (v1.4)
  * Rename mod
  * Prevent melee class from using ranged weapons other than the flamethrower
    and flame cannon, since in a separate mod, brutalv22-ammo_boost_start_v1.1,
    we now give the class a Berserk pack at the start
  * Make the Berserk pack pickup act only as a medikit
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Mon, 23 June 2025 14:28:41 -0500

brutalv22_gren_melee_and_downanywhere_support (v1.5)
  * Prevent absolutely weapons from being picked up by players of forbidden
    classes. This ensures that the weapons are available for the intended
    player classes in cooperative mode.
  * Adjust which classes are allowed to pickup or use Demonslayer, Flame Cannon,
    Flamethrower, Axe, and Chainsaw to be consistent with the policy that
    Melee class can use only melee weapons, thrown weapons, and the
    flamethrower. Also, non-Melee classes can't use melee weapons.
  * Move actors/PlayerClasses/Footsteps.dec from brutalv22-ammo_boost_start
    v1.1 to this mod
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sun, 06 July 2025 11:37:06 -0500

brutalv22_gren_melee_and_downanywhere_support (v1.6)
  * Enable damage event handling scripts for players in order to support
    brutalv22_resp_upgr_radsuit.
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Mon, 14 July 2025 13:29:12 -0500

brutalv22_gren_melee_and_downanywhere_support (v1.7)
  * Merge in the modifications by brutalv22-ammo_dropper_rifleammo_fix in order
    to ensure that the amount of bullets dropped by the Ammo Dropper is
    consistent with the amount of bullets taken. Drop 10 bullets per activation
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sat, 09 August 2025 10:33:57 -0500
 
 brutalv22_gren_melee_and_downanywhere_support (v1.8pre)
  * Add riot shield to melee class on start
 -- Edewaa  Mon, 11 August 2025 23:34:00 +0200

 brutalv22_gren_melee_and_downanywhere_support (v1.8)
  * Give Flamethrower to the melee class on start
  * Merge the changes from brutalv22-stomp_bug_fix_v2 in order to prevent
    footstep and tackle damage from other players.
  * Change the order of Player.StartItem entries to be more consistent with the
    names of each class, since the first StartItem listed is the weapon that
    the player will start with
  * Add Player.StartItem entries for ammo as starting loadout that is
    consistent with the ammo ensured by brutalv22_ammo_start_and_drop_death
  * Prevent lava splash damage to Tactical class in order to improve balance
    among the classes
  * Improve formatting of documentation
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sun, 24 August 2025 15:34:44 -0500

 brutalv22_gren_melee_and_downanywhere_support (v1.9)
  * Correct the changelog of v1.8
  * Correct the merge of brutalv22-stomp_bug_fix_v2
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Wed, 27 August 2025 13:44:10 -0500

// -- bd22_reworked_sniper_rifle -----------------------------------------------

bd22_reworked_sniper_rifle (v2):
 * changed main ammo type to shells
 * changed secondary ammo type to xm31Ammo
 * removed pierce ability
 * increased damage
 * decreased mag size to 8
 * increased ammo usage to 2 per loaded round, doubling it's ammo usage
 * decreased spawn rate a bit
 -- Remster  Sun, 04 May 2025

bd22_reworked_sniper_rifle (v3):
 * added XM21BOLT sound from XM21 rifle addon
 * changed fire animations to include bolt-action, decreasing it's fire rate
 * changed sprint sprites
 * decrease mag size to 7
 -- Remster  Sat, 17 May 2025

bd22_reworked_sniper_rifle (v3.1):
 * forbid use of the sniper rifle by the melee class
 * update SniperReplacer2 to be mostly copy/paste from bd22test5rc2 instead of
   brutalv21-sniper_v3.4. An example improvement: corrected the initial sprite
   of the spawned pickup
 * ensure that SniperAmmo is also overridden to be technically shotgun ammo
 -- Norse_Harold <norseharold@norseharold.anonaddy.com>  Sat, 05 July 2025 13:04:55 -0500

// -- Class vision -------------------------------------------------------------

v6.5
* No more Axe and Pistol for CQC on when starting
* MGL primary fire fires underbarrel rifle's grenades, but faster than the Rocket Launcher
  alt-fire is slower
* LMG Rapid fire mode is slower by 1 frame (similar to Tactical rifle fire speed)
* DEagle and Dual DEagles automatically refired when continuously pressing the
  fire button, spam clicking is faster anyway
* Changed fake weapon spawners to be visible from 3 to 5 tics to prevent
  visual blinking when having high ping
* Fixed CQC getting +50 armor on start rather than ensuring it has at least 50
* Every class starts with a total of 90 Rifle bullets rather than everyone starting
  with +60
* Fixed Shotgun tracers not being rendered correctly in multiplayer depending on the shell type
* Removed Gun Smoke from the Carbine when firing to be consistent with the other weapons
* Purist is renamed to Rifleman (Purist)
* Purist cannot use silencer
-- Edewaa  Sun, 09 November 2025 01:31:00 +0200

v6.6
* Added new class CQC (Tactical), Close Quarters Combat was renamed to
  CQC (Close Quarters Combat)
* LMG is Tactical compatible :
  * Now has a running animation
  * Recoil only for tactical
  * Fire 1 frame faster in tactical mode
* LMG firing animation is 1 frame slower, meaning that the previous fast fire
  mode and slow fire mode are 1 frame slower. This makes the weapon behave
  just like the Rifle and Carbine in attack speed and Tactical faster firing
* Riot Shield doesn't slow down Tactical Classes
* Updated Carbine startup animation
* Made Carbine's decorative tracers more consistent with fire modes and aiming modes
* Made Slug Shotgun sound punchier
-- Edewaa  Mon, 10 November 2025 02:00:00 +0200

v6.6.1
* MGL has an inspect animation (hold reload key)
* MGL plays a sound when closing its chamber after firing
* M202 player sprite (seen by others) is the Grenade Launcher
* Riot shield player sprite is fists
* Plasma Blaster pickup sprite is higher
-- Edewaa  Mon, 10 November 2025 23:02:00 +0200

v6.6.2
* Added CVars for Drop On Death functionality :
  DOD_allowWeaponDrop, DOD_allowAmmoDrop and DOD_allowArmorDrop, all true by default
* Plasma Blaster now deals damage in Deathmatch
* Updated obituary messages for deathmatch
* Plasma Blaster and MK2 projectiles explode when touching the sky
-- Edewaa  Tue, 11 November 2025 14:46:00 +0200

v6.6.3
* Riflemen classes (Purist, Normal, Tactical) start with 25 armor
* Deathmatch :
  * DEagles deal less damage
  * Plasma MK2 deals less damage, has a smaller explosion area and deals self-damage
* M202's rockets don't go through players anymore, no matter the gamemode
* Plasma MK2 projectile is very slightly affected by gravity
-- Edewaa  Wed, 12 November 2025 00:26:00 +0200

v6.7
* Every weapon is selectable by every class, but if the weapon is forbidden to its class,
  it will convert to one that is usable. It means that if someone dies and drops a Rocket Launcher,
  if CQC grabs it, it will convert automatically to a MGL.
  However, it means that some weapons aren't backward compatible, if a Railgun is dropped
  and CQC takes it, it will be a Plasma Blaster, but if it is retaken by Rifleman or Marksman,
  it will not be a Railgun but a MK2 / Plasma Rifle. And if a player get a weapon which turns
  into one it already had, it will be dropped on the ground
* Desert Eagle and Dual variant deals less damage in tactical mode, from 75 to 60 (normal is 50)
* Removed slow fire mode of the LMG
* LMG zoom when aiming changed from 1.5 to 1.25
* LMG Horizontal spread when aiming is 2.5 rather than 2.0, Chaingun is 3.0 for comparison
* Rifle innacuracy when aiming changed from 0.75 to 0.6
* Carbine :
 * First bullet fired is 100% acurate when aiming, like the Rifle
 * Zoom when aiming on fast mode changed from 2.0 to 1.75
 * Fast mode inaccuracy changed
  * from : 1.5 when not aiming and 0.4 when aiming
  * to   : 1.0 when not aiming and 0.6 when aiming
* Carbine and LMG decorative tracers have been fixed, they used wrong parameters,
  and they now take these changes into account as well
* Riflemans start with 3 rockets (intended for underbarrel rifle) and 2 grenades,
* Ammo boost script updated for the last 2 changes
* Plasma Blaster and Plasma Rifle deal friendly fire now, beware !
  (Done by disabling THRUSPECIES, MTHRUSPECIES and SPECTRAL flags, SPECTRAL made
  Revenant missiles immune to Plasma projectiles, which now aren't)
* Added PlasmagunMarine.dec so that they shoot a friendly-fire friendly projectile
* Plasma Blaster deals 50 less damage since its damage was too strong compared to
  how much it actually costs to fire a shot
* Plasma Blaster doesn't fire 1 projectile exactly where the cursor was aiming anymore
  because of the above change
* Reverted Plasma MK2 being affected by gravity to prevent bugs
* Plasma MK2 uses the Plasma Rifle crosshair instead of the Sniper crosshair
* Added CVars for Drop On Death functionality DOD_allowBackpackDrop, true by default
* Tactical CQC has an Axe instead of Berserk
* CQC starts with 125 Fuel rather than 200, Tactical CQC starts with 175
* Riot Shield height changed from 60 to 80, radius from 20 to 25
* Riot Shield bash attack is similar to the kick attack, affected by berserk
* Riot Shield doesn't punch itself when you do a bash attack
-- Edewaa  Sat, 16 November 2025 14:28:00 +0200

v6.7.1
* When selecting a weapon you can't use, and if you already have the equivalent
  of this weapon for your class 
  (such as grabbing a MGL when you already have a RL as a Rifleman) you'll
  select a weapon of that slot instead of switching to the weapon with the highest priority
-- Edewaa  Wed, 19 November 2025 16:01:00 +0200

v6.7.2
* Fixed Rifle having perfect accuracy when holding aim but not when toggling aim
-- Edewaa  Thu, 20 November 2025 01:10:00 +0200

v6.7.3
* Plasma MK2 :
 * Magazine capacity set to 5 rather than 8
 * Projectiles are slightly slower (from 150 to 120, plasma rifle is 60)
 * Fixed damage being too high by spawning an explosion with ExplosiveImpact damage type
   it also makes small demons bounce like with a normal explosion
* Plasma Blaster :
 * Spread pattern is more grid/pixely like, just like the Plasma Rifle alt fire pattern.
 * Projectiles deal 25% more damage (from 20 to 25)
* MGL's alt-fire has the same explosion radius as the primary fire, primary fire
  fires 1 frame slower (still 1 frame faster than RL)
* Fixed MGL unable to unload if you had 0 rockets in your inventory
* M202 :
 * Reload animation is 2x slower
 * Only has access to incendiary rockets, these rockets deal less damage on direct impact than
   regular rockets from RL, but the secondary projectiles of the Incendiary rockets are
   fired in an arc rather than in a circle around it's ground zero
 * When not zooming, rockets have reduced speed, similar to the Rocket Launcher
 * Rockets's willy pete particles explode in a 33% bigger area
* Carbine startup animation can be skipped by firing
* Chaingun comes before LMG on slot 4
* LMG, Carbine, MK2, MGL and Blaster all can refire after reloading if you keep pressing the
  fire button, just like almost every other weapon for consistency
* Sniper :
 * Has 4+1 ammo in its mag, uses 10 rifle ammo, deals 200 + 50 damage at close range only,
   tactical does +100 damage at all range but much slower reload time
 * Firing animation is 35 frames (1 sec), it was 3 frames faster before
 * Recoil animation when not aiming uses sprites it was supposed to use but were
   somehow unused in the code. Also added visual recoil similar to the Shotgun / SSG
   also removed random angle when shooting while aiming
 * Crosshair when stoping aim is the sniper's crosshair rather than the Rifle crosshair
 * Can refire by continuously pressing the attack button when aiming
* Revolver alt fire animation is 25% slower
* Grenade Launcher reloads 6 frames faster
* Plasma Rifle alt fire is a symmetrical, predictable pattern
* Assault Shotgun gets progressively more inaccurate the longer you shoot :
 * After shooting at least 3 times : +20% horizontal spread, 10% vertical, maximum random horizontal recoil is 2x higher
 * After shooting at least 5 times : +40% horizontal spread, 20% vertical, maximum random horizontal recoil is 3x higher
 * After shooting at least 8 times : +60% horizontal spread, 30% vertical, maximum random horizontal recoil is 4x higher
* Downed players can't grab things using the dual key
* Riflemans start with suppressed variant of the pistol rather than the normal one
-- Edewaa  Wed, 26 November 2025 23:00:00 +0200

v6.7.4
* Fixed Carbine displaying the reticle when throwing a grenade while aiming down sights on fast firing mode
* The SSG spawner only ever spawns one weapon
* Fixed weapon conversion code from causing servers desyncs
-- Edewaa  Sun, 30 November 2025 17:56:00 +0200

v6.7.5
* Tactical CQC starts with Berserk instead of an Axe, the Gas it starts with is 125, like the non-tactical variant
* If Marksmans or Riflemans grab a MGL while already having a Rocket Launcher, it will convert to
  a Grenade Launcher / M202 depending on the class. Same logic for Plasma Blaster
* Added keybinds for "Drop Inventory" and "Drop Inventory And Spectate"
* Drop Inventory on Death (aka DOD) backpacks now take into account revenant launchers, also removed grenades
  as their capacity doesn't change with a backpack
* DOD now drops a BFG instead of a Nuke if the Nuke was fired
* The SSG can use Slug shells
* Shotgun and SSG displays a message telling you that you can change the ammo type
* Slug shells deal the same damage as buckshot
* Shotgun slug mode fires only 1 bullet, and is more inaccurate than before when aiming (1.25 when not aiming, 1.0 when aiming)
* DEagle is more inaccurate than before when aiming (1.0 when not aiming, 0.8 when aiming)
* Carbine slow fire mode has a zoom of 3x instead of 3.5x
* Carbine slow fire mode is more inaccurate than before when aiming (0.3, rifle is 0.6 when aiming),
  first bullet fired remains 100% accurate
* Rocket Launcher's inaccuracy when not aiming is now the same as the Plasma Rifle (from 1.0 to 0.7)
* Grenade Launcher attack speed is faster by another 4 frames, so 10 frames in total
* Grenade Launcher has a long distance mode when pressing the dual wield key
* Plasma Rifle alt fire has a different pattern
* Plasma Rifle MK2 has an inspect animation
* Plasma Rifle MK2 projectile does 200 direct damage and an explosion that does 50, the explosion is also smaller
* Plasma Rifle MK2 projectile is 2x faster when aiming
* Plasma Rifle MK2 is less accurate when not aiming (0.7, same as Plasma Rifle)
* Plasma Rifle, MK2 and Rocket Launcher inaccuracy when not aiming is lower vertically than horizontally
* Plasma Blaster has an inspect animation
* Plasma Blaster allows quick switch when pumping (You can change weapon but you'll still need to pump at some point)
* Plasma Blaster has the guarantee to fire 3 projectiles where the player is aiming, with random horizontal spread only.
  Making the weapon at least slightly viable at a distance
* Plasma Blaster now uses the SSG crosshair
* Revolver alt fire animation updated
* Fixed LMG and MGL sprite being incorrect when entering the StopSprintTired state
* Fixed Grenade Launcher inspection having bobbing disabled (BD bug)
* Fixed Revolver having a little bit of recoil for non-tactical classes (BD bug)
* Fixed Shotgun not being able to fire during first select animation (BD bug)
* Fixed Dual Deagles being called Deagle
* Fixed suppressed pistols having the same tag as their normal variants
* Fixed LMG using Chaingun crosshair instead of Rifle
* Fixed LMG, Carbine and MGL refilling its magazine when picking it up from dead pals
* Removed CantUseScopes and CanChangeShellType, we use IsMarksmanClass now
-- Edewaa  Fri, 12 December 2025 00:20:00 +0200

v6.7.5.3
* Fixed quick grenade throw from taking ammo from weapons without magazines like the BFG or the Chaingun
  This was due to the useammo parameter set to true in DEFAULTWEAPON.dec in the TossGrenade state
  because of a change we did to make grenades behave like in v21
  Thank you Remster !
-- Edewaa  Tue, 16 December 2025 22:08:00 +0200

v6.7.6
* Marksmans get a regular shotgun in addition to the Sniper when grabbing a map placed SSG only
* Added a message saying that the Carbine has 2 fire modes on its first selection
* Slow and Rapid fire modes have different colors displayed on the message
* Fixed Riflemans being able to use Shotgun slugs if they had slugs selected for the SSG.
  Both weapons use their own specific inventory item
* SSG uses a special crosshair when using slug shells
* Marksmans can use the Dual SMG when grabbing another SMG from the Chaingun spawner
  (both map placed Chaingun and dropped Chaingun from Chaingunner)
* The MGL fires 1 frame faster
-- Edewaa  Wed, 14 January 2026 20:50:00 +0200

v6.8
* Updated to test 6
* DEagle has an inspect animation
* MGL has a capacity of 8 rather than 6, but reload is slightly longer
* Plasma Blaster has a capacity of 12 rather than 8
* Plasma MK2 has a capacity of 6 rather than 5
* Plasma Rifle alt fire has been changed
* Many bugfixes
-- Edewaa  Tue, 21 April 2026 00:06:00 +0200
